Pairs Forming LCM LightOJ - 1236

题目链接:https://cn.vjudge.net/problem/LightOJ-1236

Find the result of the following code:

long long pairsFormLCM( int n ) {
    long long res = 0;
    for( int i = 1; i <= n; i++ )
        for( int j = i; j <= n; j++ )
           if( lcm(i, j) == n ) res++; // lcm means least common multiple
    return res;
}

A straight forward implementation of the code may time out. If you analyze the code, you will find that the code actually counts the number of pairs (i, j) for which lcm(i, j) = n and (i ≤ j).

Input

Input starts with an integer T (≤ 200), denoting the number of test cases.

Each case starts with a line containing an integer n (1 ≤ n ≤ 1014).

Output

For each case, print the case number and the value returned by the function 'pairsFormLCM(n)'.

Sample Input

15

2

3

4

6

8

10

12

15

18

20

21

24

25

27

29

Sample Output

Case 1: 2

Case 2: 2

Case 3: 3

Case 4: 5

Case 5: 4

Case 6: 5

Case 7: 8

Case 8: 5

Case 9: 8

Case 10: 8

Case 11: 5

Case 12: 11

Case 13: 3

Case 14: 4

Case 15: 2

题目大意:给你一个数n  求满足lcm(a, b) == n, a <= b 的 (a,b) 的个数。

思路:唯一分解定理。求出每个素因子的个数xi,然后t=(2*x1+1)*......(n*xi+1),然后i==j只有一种所以i<j的有(t-1)/2所以加上i==j的(t+1)/2就是答案。

代码:

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int maxn=1e7+10;
ll prime[maxn/10];
bool vis[maxn];
int cnt=0;
void oula()
{
    memset(vis,false,sizeof(vis));
    memset(prime,0,sizeof(prime));
    for(int i=2;i<=maxn;i++)
    {
        if(!vis[i])
        {
            prime[cnt++]=i;
        }
        for(int j=0;j<cnt&&i*prime[j]<=maxn;j++)
        {
            vis[i*prime[j]]=true;
            if(i%prime[j]==0)
            break;
        }
    }
}
int main()
{
    oula();
    int t;
    scanf("%d",&t);
    for(int kcase=1;kcase<=t;kcase++)
    {
        ll n;
        scanf("%lld",&n);
        ll ans=1;
        for(int i=0;i<cnt&&prime[i]*prime[i]<=n;i++)
        {
            ll num=0;
            while(n%prime[i]==0)
            {
                num++;
                n/=prime[i];
            }
            ans*=(2*num+1);
        }
        if(n>1)
        ans*=3;
        ans=(ans+1)/2;
        cout<<"Case "<<kcase<<": "<<ans<<endl;
    }
}

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
All-Pairs Shortest Path问题是指在一个带权有向图中,求出任意两个节点之间的最短路径。解决这个问题的算法称为All-Pairs Shortest Path算法。 常用的All-Pairs Shortest Path算法有Floyd-Warshall算法和Johnson算法。 Floyd-Warshall算法的基本思想是动态规划。用dist[i][j]表示从节点i到节点j的最短路径长度,用k表示中间节点,则有状态转移方程: ``` dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]) ``` 其中,dist[i][j]的初始值为节点i到节点j的边权,如果i和j之间没有边,则为正无穷。算法的核心是对k从1到n的循环,依次更新dist[i][j]的值,最终得到所有节点之间的最短路径长度。 Floyd-Warshall算法的时间复杂度为O(n^3),其中n为节点数,主要时间花费在三层循环上,实际应用中可以通过空间换时间的方式优化算法。 Johnson算法的基本思想是通过引入一个虚拟节点,并将其与所有节点之间的边权设为0,将问题转化为带权有向图中的单源最短路径问题。然后使用Bellman-Ford算法求出虚拟节点到其它所有节点的最短路径长度,再用求最短路径时的松弛操作更新所有边的边权,将问题转化为带权有向图中的多源最短路径问题。最后使用Dijkstra算法求出所有节点之间的最短路径长度。 Johnson算法的时间复杂度为O(n^2logn+m),其中n为节点数,m为边数,主要时间花费在Bellman-Ford算法和Dijkstra算法上,实际应用中可以通过优化数据结构等方式优化算法。

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值